                $INCLUDE (Map.inc)                

				 NAME     Key
			     PUBLIC   Key_Init
				 PUBLIC   Key_Scan

KeyVariable      SEGMENT  DATA
                 RSEG     KeyVariable

Key_Trig_Count : DS       0x01
;Module variable allocation.

Key_Func         SEGMENT  CODE
                 RSEG      Key_Func

Key_Init:	     ANL      P3M0,#0xFB
                 ANL      P3M1,#0xFB
;P3.2 is Quasi-bidirectional pins.
                 SETB     P32
;Pull up P3.2.
                 RET

Key_Scan:        JNB      P32,Key_Pressed
;Check whether the key is pressed.
                 MOV      A,Key_Trig_Count
				 SUBB     A,#0x40
				 JNC      Key_Long_press
;Identify key operation, short pressed or long pressed.
;Check how long dese the key was pressed. It will be
;ingnored if the operation did not keep for enough time.
                 MOV      A,Key_Trig_Count
				 SUBB     A,#0x07
				 JC       Key_Op_Invalid
;Does the operation too short to be a valid input?
				 MOV      R7,#0x01
				 MOV      Key_Trig_Count,#0x00
;Valid key operation is dected, key short pressed.
;R7 is setted to 1 while the counter is resetted.
                 RET
Key_Long_press:  MOV      R7,#0x02
                 MOV      Key_Trig_Count,#0x00
;Valid key operation is dected, key long pressed. R7
;is setted to 1 while the counter is resetted.
                 RET
Key_Op_Invalid:	 CLR      A
                 MOV      Key_Trig_Count,A
				 MOV      R7,A
;No valid key operation is dected, R7 is
;setted to 0 as well as the counter0.
				 RET
Key_Pressed:     MOV      A,Key_Trig_Count
                 CJNE     A,#0xFF,KT_Count_N_Ov
;When the counter0 is equal to 0xFF, it will
;not increase to avoid overflow.
                 MOV      R7,#0x00
;The key is still pressed, without valid key value
;to return, R7 remains 0.
				 RET
KT_Count_N_Ov:   INC      Key_Trig_Count
;When the counter0 is lower than 0xFF, it
;keeps increasing.
				 MOV      R7,#0x00
;The key is still pressed, without valid key value
;to return, R7 remains 0.
                 RET
				 
				 END