                 $INCLUDE (Map.inc)

				 NAME     Main
				 PUBLIC   Main

				 EXTRN    CODE  (WDT_init)
                 EXTRN    CODE  (Key_Init)	
				 EXTRN    CODE  (ADC_Init)
				 EXTRN    CODE  (PWM_Init)
				 EXTRN    CODE  (Timer0_Init)
				 EXTRN    CODE  (Extra_IO_Init)
				 EXTRN    CODE  (Task1_init)
				 EXTRN    CODE  (Task2_init)
				 EXTRN    CODE  (Task1)
				 EXTRN    CODE  (Task2)
				 EXTRN    CODE  (Task3)

MainFunc         SEGMENT  CODE
                 RSEG     MainFunc
			
Main:			 CLR      P30
;Force P3.0 to low level immediately after reset. The initial
;state of all GPIOs are high level.
                 ACALL    Power_On_Delay
;Wait power become stable.
                 ACALL    WDT_init
				 ACALL    Key_Init
                 ACALL    ADC_Init
				 ACALL    Extra_IO_Init
				 ACALL    Timer0_Init
				 ACALL    PWM_Init
;Initialize all necessary peripherals.
				 ACALL    Task1_init
				 ACALL    Task2_init
;Task initialization.
Task_cycle:      ACALL    Task1
                 ACALL    Task2
				 ACALL    Task3
                 CPL      P36
                 JMP      Task_cycle
;End of main

Power_On_Delay:  CLR      A
                 MOV      R0,A
				 MOV      R1,A
				 MOV      R2,A
DelayLoop:       MOV      A,R0
                 ADD      A,#0x03
				 MOV      R0,A
				 MOV      A,R1
                 ADDC     A,#0x00
				 MOV      R1,A
				 MOV      A,R2
                 ADDC     A,#0x00
				 MOV      R2,A
				 CLR      C
				 ADD      A,#0x01
				 JNC      DelayLoop
                 RET

                 END

;GPIO function description:
;P1.5: analog input for ADC;
;P1.0, P1.1: PWM output for LED flashing. 
;P3.7: PWM output for boost circuit.
;P3.0: fogger ceramics disc driving signal output.
;P3.2: external key input.  
;P5.4, P5.5: Square wave input&output for liquid level decting.