                 $INCLUDE (Map.inc)                
 
				 NAME     PWM
			     PUBLIC   PWM_Init
				 PUBLIC   LED_PWM_DC_Set
				 PUBLIC   Fogger_Drv_Con
				 PUBLIC   PWM_Sim_Gate_Drv
				 PUBLIC   LED_PWM_Control
				 PUBLIC   Boost_PWM_Cont
				 EXTRN    CODE  (Sin_Wav_Tab)
				 EXTRN    DATA  (Fogger_Drv_DC)
				 
PWMVariable      SEGMENT  DATA
                 RSEG     PWMVariable

LED_PWM_Step_Ct: DS       0x01
PWM_Simulate_Ct: DS       0x01
;Module variable allocation.
PWM_Func         SEGMENT  CODE
                 RSEG     PWM_Func

PWM_Init:	     ORL      AUXR,#0x04
;Timer2 works in 1T model.
                 ANL      AUXR,#0xF7
;Clock source of timer2 is internal clock.
                 MOV      T2L,#0x53
				 MOV      T2H,#0xFF
;The expected output frequency is (37.4/173)/2=108.09KHz.
                 ORL      AUXR,#0x10
;Timer2 starts counting.
                 SETB     P30
;Pull down P3.0 to ensure the MOSFET is turned off.
;fogger ceramics disc driving signal configuration.
                 ORL      P1M0,#0x04
				 ANL      P1M1,#0xFB
				 CLR      P12
;This P1.2 is connected to MOSFET gate driver enable pin.
                 ORL      P1M0,#0x03
				 ANL      P1M1,#0xFC
;P1.0, P1,1 is push-pull model.
                 ORL      P3M0,#0x80
				 ANL      P3M1,#0x7F
				 CLR      P37
;P3.7 is push-pull model. Output level is forced to 0.
				 ANL      P_SW1,#0xCF
;Select P1.0, P1.1, P3.7 as CCP1, CCP0, CCP2.
                 CLR      CR
;Stop PCA timer.
                 CLR      A
				 MOV      CL,A
				 MOV      CH,A
;PCA Base Timer reset.
                 ORL      CMOD,#0x08
;PCA Base Timer clock source is internal clock.
                 ANL      PCA_PWM0,#0x3F
				 ORL      CCAPM0,#0x42
;PCA module0 is 8-bit PWM model. Comparator function
;is allowed, CCP0 pin PWM output enable.
                 MOV      A,#0x80
                 MOV      CCAP0H,A
				 MOV      CCAP0L,A
;PCA module0 capture register initial value set,
;expected duty cycle is 50%.
                 ANL      PCA_PWM1,#0x3F
				 ORL      CCAPM1,#0x42
;PCA module11 is 8-bit PWM model. Comparator function
;is allowed, CCP1 pin PWM output enable.
                 MOV      CCAP1H,A
				 MOV      CCAP1L,A
;PCA module11 capture register initial value set,
;expected duty cycle is 50%.
;LED breath light PWM configuration.
                 ANL      PCA_PWM2,#0x3F
				 ORL      CCAPM2,#0x42
;PCA module2 is 8-bit PWM model. Comparator function
;is allowed, CCP2 pin PWM output enable.
                 CLR      A
                 MOV      CCAP2H,A
				 MOV      CCAP2L,A
;PCA module2 capture register initial value set,
;expected duty cycle is 100%.
;Boost circuit PWM configuration.
			     SETB     CR
;Start PCA timer. three-way PWM output enable.
                 RET
;This function initializes all necessary PWM module.
LED_PWM_DC_Set:  INC      LED_PWM_Step_Ct
;The value of LED PWM step counter plus 1.
                 MOV      A,#0x10
				 ADD      A,LED_PWM_Step_Ct
				 JNC      LPS_Ct_Rst_Skip
;Check the value of LED PWM step counter,if it is more than
;359, it will be reset.
LPS_Ct_Rst:      MOV      LED_PWM_Step_Ct,A
;Reset LED PWM step counter.
LPS_Ct_Rst_Skip: MOV      A,#0x88
                 ADD      A,LED_PWM_Step_Ct
				 JNC      Tab_of_Lt_119
;Check LED PWM step counter's value is less than 119 or equal
;to 119.
                 MOV      DPTR,#Sin_Wav_Tab
				 MOVC     A,@A+DPTR
;Get PWM duty cycle value from lookup table.
				 MOV      CCAP1H,A
		         CLR      C
				 MOV      A,#0xFF
				 SUBB     A,CCAP1H
				 MOV      CCAP0H,A
;Update PWM duty cycle.
				 RET
Tab_of_Lt_119:   MOV      A,LED_PWM_Step_Ct
                 MOV      DPTR,#Sin_Wav_Tab
				 MOVC     A,@A+DPTR
;Get PWM duty cycle value from lookup table.
                 MOV      CCAP0H,A
				 MOV      A,#0xFF
				 SUBB     A,CCAP0H
				 MOV      CCAP1H,A
;Update PWM duty cycle.
                 RET
;PWM output duty cycle cotrol for LED breath light.
LED_PWM_Control: JC       LED_On
                 ANL      CCAPM0,#0xBD
                 ANL      CCAPM1,#0xBD
;Disable the PWM function for P1.0 and P1.1.
                 ANL      P1,#0xFC
;P1.0 and P1.1 are forced to low so that the
;LED can be shutdowned completely.
				 RET
LED_On:		     ORL      CCAPM0,#0x42
                 ORL      CCAPM1,#0x42
;Recover the PWM function for P1.0 and P1.1.
                 RET
;LED breath light control.
PWM_Sim_Gate_Drv:MOV      A,Fogger_Drv_DC
                 SUBB     A,PWM_Simulate_Ct
;Compare two variables, if PWM_Simulate_Ct is higher than
;Fogger_Drv_DC, P1.2 will be setted to low.
				 INC      PWM_Simulate_Ct
;Update PWM_Simulate_Ct.
				 JC       MOSFET_Drv_Dis
MOSFET_Drv_En:	 JB       P12,PSGV_Ret
;Check current P1.2 state, if it is already high, no
;further action needs to be taken.
                 SETB     P12
;MOSFET driver is enabled.
PSGV_Ret:        RET
MOSFET_Drv_Dis:  JNB      P12,PSGV_Ret
;Check current P1.2 state, if it is already low, no
;further action needs to be taken.
                 CLR      P12
;MOSFET driver is disabled.
                 RET
;Due to the lack of the hardware PWM output channel,
;software simulation PWM is used to control the MOSFET
;gate driver of the class-E amplifier, so the average
;output power of the Fogger ceramics disc also can be
;controled.
Fogger_Drv_Con:  JC       Fogger_Drv_En
Fogger_Drv_Dis:  ANL      INT_CLKO,#0xFB
;Clock output output disable.
                 CLR      P30
;Make sure P3.0 is low after clock output function
;is disabled.
                 RET
Fogger_Drv_En:   ORL      INT_CLKO,#0x04
;Clock output enable.
                 RET
;Fogger ceramics disc driving signal output control.

                 CSEG     AT    0x3E

Boost_PWM_Cont:  JC       Boost_En
                 ANL      CCAPM2,#0xBD
;Disable the PWM function for P3.7.
                 SETB     P37
;P3.7 are forced to high to avoid short-circuit.
                 RET
Boost_En:	     ORL      CCAPM2,#0x42
;Recover the PWM function for P3.7.
                 RET
;Boost circuit control.
                 END