                 $INCLUDE (Map.inc)                

				 NAME     Timer
			     PUBLIC   Timer0_Init
				 PUBLIC   Timer0_handler
				 EXTRN    CODE  (ADC_Start)
				 EXTRN    CODE  (PID_Con_For_PWM)
				 EXTRN    CODE  (LED_PWM_DC_Set)
				 EXTRN    CODE  (PWM_Sim_Gate_Drv)
				 EXTRN    CODE  (Key_Scan)
				 EXTRN    DATA  (Key_Event)
				 EXTRN    BIT  (Fogger_Drv_Allow)

TimerVariable    SEGMENT  DATA
                 RSEG     TimerVariable

Interrupt_Count: DS       0x02
;Module variable allocation.

Timer_Func       SEGMENT  CODE
                 RSEG     Timer_Func

Timer0_Init:	 ORL       AUXR,#0x80
;Timer0 works in 1T model.
                 CLR       A
                 MOV       TMOD,A
;Timer0 is setted to 16-bit auto reload model.
                 MOV       TL0,#0x00
				 MOV       TH0,#0xFD
;Auto relaod value set.
                 SETB      TR0
;Start timer0.
                 ORL       IE,#0x82
;Timer0 and globle interrupt are allowed.
                 RET

Timer0_handler:  PUSH      PSW
                 PUSH      0xE0
				 SETB      PSW.3
;Using register group 1.
                 ACALL     ADC_Start
;Get current output voltage sample.
                 ACALL     PID_Con_For_PWM
;Use PID controler to set pulse width.
                 ACALL     PWM_Sim_Gate_Drv
;PWM simulation for fogger ceramics disc average
;output power control.
PSGV_Skip:   	 MOV       A,#0x01
				 ADD       A,Interrupt_Count
				 MOV       Interrupt_Count,A
				 CLR       A
				 ADDC      A,Interrupt_Count+1
				 MOV       Interrupt_Count+1,A
;Counter plus one, when the counter's value is equal to
;a specific value, some addtional actions will be
;execute.
                 CJNE      A,#0x02,Action_Skip
				 CLR       A
				 MOV       Interrupt_Count,A
				 MOV       Interrupt_Count+1,A
;Counter is resetted to 0 after it reached the specific
;value.
				 ACALL     LED_PWM_DC_Set
;Change LED light.
				 ACALL     Key_Scan
;Get key input.
				 MOV       Key_Event,R7
;Set key event flag according to the key input.
Action_Skip:     POP       0xE0
				 POP       PSW
;Recovery registers which were modified before.
                 RETI

                 END